glibmm 2.88.0

Public Member Functions | Protected Member Functions | List of all members
Gio::TlsServerConnectionImpl Class Reference

Gio::TlsServerConnectionImpl is a Gio::TlsConnection that implements the Gio::TlsServerConnection interface. More...

`#include <giomm/tlsserverconnectionimpl.h>`

Inheritance diagram for Gio::TlsServerConnectionImpl:
[legend]

## Public Member Functions
| TlsServerConnectionImpl (TlsServerConnectionImpl &&src) noexcept
TlsServerConnectionImpl & | operator= (TlsServerConnectionImpl &&src) noexcept
| ~TlsServerConnectionImpl () noexcept override
Public Member Functions inherited from Gio::TlsServerConnection
| TlsServerConnection (TlsServerConnection &&src) noexcept
TlsServerConnection & | operator= (TlsServerConnection &&src) noexcept
| ~TlsServerConnection () noexcept override
GTlsServerConnection * | gobj ()
| Provides access to the underlying C GObject.
const GTlsServerConnection * | gobj () const
| Provides access to the underlying C GObject.
Glib::PropertyProxy< TlsAuthenticationMode > | property_authentication_mode ()
| The TlsAuthenticationMode for the server.
Glib::PropertyProxy_ReadOnly< TlsAuthenticationMode > | property_authentication_mode () const
| The TlsAuthenticationMode for the server.
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor.
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Called by constructors of derived classes.
| Interface (GObject *castitem)
| Called by constructors of derived classes.
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring & property_name, const Glib::ValueBase & value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring & property_name, Glib::ValueBase & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | set_property (const Glib::ustring & property_name, const PropertyType & value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | get_property (const Glib::ustring & property_name, PropertyType & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
PropertyType | get_property (const Glib::ustring & property_name) const
| You probably want to use a specific property_*() accessor method instead.
sigc::connection | connect_property_changed (const Glib::ustring & property_name, const sigc::slot< void()> & slot)
| You can use the signal_changed() signal of the property proxy instead.
sigc::connection | connect_property_changed (const Glib::ustring & property_name, sigc::slot< void()> && slot)
| You can use the signal_changed() signal of the property proxy instead.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject * | gobj ()
| Provides access to the underlying C GObject.
const GObject * | gobj () const
| Provides access to the underlying C GObject.
GObject * | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const
Public Member Functions inherited from Gio::TlsConnection
| TlsConnection (TlsConnection &&src) noexcept
TlsConnection & | operator= (TlsConnection &&src) noexcept
| ~TlsConnection () noexcept override
GTlsConnection * | gobj ()
| Provides access to the underlying C GObject.
const GTlsConnection * | gobj () const
| Provides access to the underlying C GObject.
GTlsConnection * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
void | set_certificate (const Glib::RefPtr< TlsCertificate > &certificate)
| This sets the certificate that conn will present to its peer during the TLS handshake.
Glib::RefPtr< TlsCertificate > | get_certificate ()
| Gets conn's certificate, as set by g_tls_connection_set_certificate().
Glib::RefPtr< const TlsCertificate > | get_certificate () const
| Gets conn's certificate, as set by g_tls_connection_set_certificate().
Glib::RefPtr< TlsCertificate > | get_peer_certificate ()
| Gets conn's peer's certificate after the handshake has completed or failed.
Glib::RefPtr< const TlsCertificate > | get_peer_certificate () const
| Gets conn's peer's certificate after the handshake has completed or failed.
TlsCertificateFlags | get_peer_certificate_errors () const
| Gets the errors associated with validating conn's peer's certificate, after the handshake has completed or failed.
void | set_require_close_notify (bool require_close_notify=true)
| Sets whether or not conn expects a proper TLS close notification before the connection is closed.
bool | get_require_close_notify () const
| Tests whether or not conn expects a proper TLS close notification when the connection is closed.
Glib::RefPtr< TlsDatabase > | get_database ()
| Gets the certificate database that conn uses to verify peer certificates.
Glib::RefPtr< const TlsDatabase > | get_database () const
| Gets the certificate database that conn uses to verify peer certificates.
void | set_database (const Glib::RefPtr< TlsDatabase > &database)
| Sets the certificate database that is used to verify peer certificates.
Glib::RefPtr< TlsInteraction > | get_interaction ()
| Get the object that will be used to interact with the user.
Glib::RefPtr< const TlsInteraction > | get_interaction () const
| Get the object that will be used to interact with the user.
void | set_interaction (const Glib::RefPtr< TlsInteraction > &interaction)
| Set the object that will be used to interact with the user.
bool | handshake (const Glib::RefPtr< Cancellable > &cancellable)
| Attempts a TLS handshake on conn.
bool | handshake ()
| A handshake() convenience overload.
void | handshake_async (const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > &cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Asynchronously performs a TLS handshake on conn.
void | handshake_async (const SlotAsyncReady & slot, int io_priority=Glib::PRIORITY_DEFAULT)
| A handshake_async() convenience overload.
bool | handshake_finish (const Glib::RefPtr< AsyncResult > &result)
| Finish an asynchronous TLS handshake operation.
TlsProtocolVersion | get_protocol_version () const
| Returns the current TLS protocol version, which may be Gio::TlsProtocolVersion::UNKNOWN if the connection has not handshaked, or has been closed, or if the TLS backend has implemented a protocol version that is not a recognized TlsProtocolVersion.
Glib::ustring | get_ciphersuite_name () const
| Returns the name of the current TLS ciphersuite, or `nullptr` if the connection has not handshaked or has been closed.
bool | emit_accept_certificate (const Glib::RefPtr< const TlsCertificate > &peer_cert, TlsCertificateFlags errors)
| Used by TlsConnection implementations to emit the TlsConnection::signal_accept_certificate() signal.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< IOStream > > | property_base_io_stream () const
| The IOStream that the connection wraps.
Glib::PropertyProxy< Glib::RefPtr< TlsCertificate > > | property_certificate ()
| The connection's certificate; see g_tls_connection_set_certificate().
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< TlsCertificate > > | property_certificate () const
| The connection's certificate; see g_tls_connection_set_certificate().
Glib::PropertyProxy< Glib::RefPtr< TlsDatabase > > | property_database ()
| The certificate database to use when verifying this TLS connection.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< TlsDatabase > > | property_database () const
| The certificate database to use when verifying this TLS connection.
Glib::PropertyProxy< Glib::RefPtr< TlsInteraction > > | property_interaction ()
| A TlsInteraction object to be used when the connection or certificate database need to interact with the user.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< TlsInteraction > > | property_interaction () const
| A TlsInteraction object to be used when the connection or certificate database need to interact with the user.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< TlsCertificate > > | property_peer_certificate () const
| The connection's peer's certificate, after the TLS handshake has completed or failed.
Glib::PropertyProxy_ReadOnly< TlsCertificateFlags > | property_peer_certificate_errors () const
| The errors noticed while verifying TlsConnection::property_peer_certificate().
Glib::PropertyProxy< bool > | property_require_close_notify ()
| Whether or not proper TLS close notification is required.
Glib::PropertyProxy_ReadOnly< bool > | property_require_close_notify () const
| Whether or not proper TLS close notification is required.
Glib::PropertyProxy_ReadOnly< TlsProtocolVersion > | property_protocol_version () const
| The TLS protocol version in use.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_ciphersuite_name () const
| The name of the TLS ciphersuite in use.
Glib::SignalProxy< bool(const Glib::RefPtr< const TlsCertificate > &, TlsCertificateFlags)> | signal_accept_certificate ()
Public Member Functions inherited from Gio::IOStream
| IOStream (IOStream &&src) noexcept
IOStream & | operator= (IOStream &&src) noexcept
| ~IOStream () noexcept override
GIOStream * | gobj ()
| Provides access to the underlying C GObject.
const GIOStream * | gobj () const
| Provides access to the underlying C GObject.
GIOStream * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
void | splice_async (const Glib::RefPtr< IOStream > &stream2, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > &cancellable, SpliceFlags flags=SpliceFlags::NONE, int io_priority=Glib::PRIORITY_DEFAULT)
| Asyncronously splice the output stream to the input stream of stream2, and splice the output stream of stream2 to the input stream of this stream.
void | splice_async (const Glib::RefPtr< IOStream > &stream2, const SlotAsyncReady & slot, SpliceFlags flags=SpliceFlags::NONE, int io_priority=Glib::PRIORITY_DEFAULT)
| A non-cancellable version of splice_async().
Glib::RefPtr< InputStream > | get_input_stream ()
| Gets the input stream for this object.
Glib::RefPtr< OutputStream > | get_output_stream ()
| Gets the output stream for this object.
bool | close (const Glib::RefPtr< Cancellable > &cancellable)
| Closes the stream, releasing resources related to it.
bool | close ()
| A close() convenience overload.
void | close_async (const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > &cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
void | close_async (const SlotAsyncReady & slot, int io_priority=Glib::PRIORITY_DEFAULT)
bool | close_finish (const Glib::RefPtr< AsyncResult > &result)
| Closes a stream.
bool | is_closed () const
| Checks if a stream is closed.
bool | has_pending () const
| Checks if a stream has pending actions.
bool | set_pending ()
| Sets stream to have actions pending.
void | clear_pending ()
| Clears the pending flag on stream.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark & key)
void | set_data (const Quark & key, void *data)
void | set_data_with_c_callback (const Quark & key, void *data, GDestroyNotify notify)
void | set_data (const Quark & key, void *data, DestroyNotify notify)
| Prefer set_data_with_c_callback() with a callback with C linkage.
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)

## Protected Member Functions
| TlsServerConnectionImpl (GTlsConnection *castitem)
Protected Member Functions inherited from Gio::TlsServerConnection
| TlsServerConnection ()
| You should derive from this class to use it.
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor.
| ObjectBase (const char *custom_type_name)
| A derived constructor always overrides this choice.
| ObjectBase (const std::type_info &custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually.
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gio::TlsConnection
| TlsConnection ()
virtual bool | handshake_vfunc (const Glib::RefPtr< Cancellable > &cancellable)
virtual void | handshake_async_vfunc (const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > &cancellable, int io_priority)
virtual bool | handshake_finish_vfunc (const Glib::RefPtr< AsyncResult > &result)
virtual bool | on_accept_certificate (const Glib::RefPtr< const TlsCertificate > &peer_cert, TlsCertificateFlags errors)
| This is a default handler for the signal signal_accept_certificate().
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override

## Additional Inherited Members
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from Gio::IOStream
enum class | SpliceFlags { SpliceFlags::NONE = 0x0 , SpliceFlags::CLOSE_STREAM1 = (1 << 0) , SpliceFlags::CLOSE_STREAM2 = (1 << 1) , SpliceFlags::WAIT_FOR_BOTH = (1 << 2) }
| GIOStreamSpliceFlags determine how streams should be spliced. More...
Public Types inherited from Glib::Object
using | DestroyNotify = void(*)(gpointer data)
Static Public Member Functions inherited from Gio::TlsServerConnection
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< TlsServerConnectionImpl > | create (const Glib::RefPtr< IOStream > &base_io_stream, const Glib::RefPtr< TlsCertificate > &certificate)
| Creates a new TlsServerConnection wrapping base_io_stream (which must have pollable input and output streams).
Static Public Member Functions inherited from Gio::TlsConnection
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gio::IOStream
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static bool | splice_finish (const Glib::RefPtr< AsyncResult > &result)
| Finishes an asynchronous io stream splice operation.
Related Symbols inherited from Gio::TlsServerConnection
Glib::RefPtr< Gio::TlsServerConnection > | wrap (GTlsServerConnection *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gio::TlsConnection
Glib::RefPtr< Gio::TlsConnection > | wrap (GTlsConnection *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gio::IOStream
Glib::RefPtr< Gio::IOStream > | wrap (GIOStream *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)

## Detailed Description

Gio::TlsServerConnectionImpl is a Gio::TlsConnection that implements the Gio::TlsServerConnection interface.

The GTlsServerConnection interface can be implemented by C classes that derive from GTlsConnection. No public GLib class implements GTlsServerConnection. Some GLib functions, such as g_tls_server_connection_new(), return an object of a class which is derived from GTlsConnection and implements GTlsServerConnection. Since that C class is not public, it's not wrapped in a C++ class. A C object of such a class can be wrapped in a Gio::TlsServerConnectionImpl object. Gio::TlsServerConnectionImpl does not directly correspond to any GLib class.

This class is intended only for wrapping C objects returned from GLib functions.

Since glibmm 2.66:

## Constructor & Destructor Documentation

## ◆ TlsServerConnectionImpl() [1/2]

Gio::TlsServerConnectionImpl::TlsServerConnectionImpl | ( | GTlsConnection * | castitem | ) |
| explicit protected

## ◆ TlsServerConnectionImpl() [2/2]

Gio::TlsServerConnectionImpl::TlsServerConnectionImpl | ( | TlsServerConnectionImpl && | src | ) |
| noexcept

## ◆ ~TlsServerConnectionImpl()

Gio::TlsServerConnectionImpl::~TlsServerConnectionImpl | ( |  | ) |
| override noexcept

## Member Function Documentation

## ◆ operator=()

TlsServerConnectionImpl & Gio::TlsServerConnectionImpl::operator= | ( | TlsServerConnectionImpl && | src | ) |
| noexcept